#pragma once

#include "NPFile.h"
#include "NAutoBuffer.h"

/**
* @ingroup 	PCM Base Lib	
* @brief 	{kr} pack://   ó {/kr}
* @date		07/24/2007
* @author	telltale
* @remark	
*/
class CNPPackFile : public INPFile
{
public:
	CNPPackFile(void);
	~CNPPackFile(void);

//override
	BOOL		Open( LPCTSTR lpszURL, DWORD dwFlags = 0 );
	void		Close();
	DWORD		Read( void* lpBuf, DWORD dwCount = 0 );
	BOOL		Write( const void* lpBuf, DWORD dwCount );
	ULONGLONG	GetSize();

//operation
	static void AppendFileToPackURL(LPTSTR pszBuffer, int nMax, LPCTSTR pszcFile);

private:
	BOOL ReadBufferFromURL(CNAutoBuffer<BYTE>& ByteArray, LPCTSTR pszcURL);

	CNAutoBuffer<BYTE>	m_BufFile;
	DWORD m_dwCurrRead;
};
